<template>
  <q-dialog
    persistent
    :maximized="maximizedToggleCal"
    transition-show="slide-up"
    transition-hide="slide-down"
    ref="dialogRef"
    @hide="onDialogHide"
  >
    <q-card class="">
      <q-bar>
        <q-space />

        <q-btn
          dense
          flat
          icon="minimize"
          @click="maximizedToggleCal = false"
          :disable="!maximizedToggleCal"
        >
          <q-tooltip v-if="maximizedToggleCal" class="bg-white text-primary">
            Minimize
          </q-tooltip>
        </q-btn>
        <q-btn
          dense
          flat
          icon="crop_square"
          @click="maximizedToggleCal = true"
          :disable="maximizedToggleCal"
        >
          <q-tooltip v-if="!maximizedToggleCal" class="bg-white text-primary">
            Maximize
          </q-tooltip>
        </q-btn>
        <q-btn dense flat icon="close" v-close-popup>
          <q-tooltip class="bg-white text-primary">Close</q-tooltip>
        </q-btn>
      </q-bar>

      <q-card-section class="q-pt-none" v-if="windowObj.typeCal === 'add'">
        <div class="text-h6">ajoutez une valeur dans un champ de donnée</div>
        <form action="">
          <q-date v-model="addCalendarDate" minimal />
          <br /><br />
          <q-input
            filled
            v-model="addCalendarValue"
            label="value"
            type="number"
          />
          <br /><br />
          <q-btn
            @click.prevent="addCalendar2(windowObj.fieldId)"
            label="enregistrer"
            type="submit"
            color="positive"
            icon="add"
          />
        </form>
      </q-card-section>

      <q-card-section class="q-pt-none" v-if="windowObj.typeCal === 'update'">
        <div class="text-h6">modifier la date</div>
        <div class="dev">
          <p>windowObj.typeCal: {{ windowObj.typeCal }}</p>
          <p>windowObj.fieldId: {{ windowObj.fieldId }}</p>
          <p>windowObj.calendarId: {{ windowObj.calendarId }}</p>
          <p>windowObj.singleCal: {{ windowObj.singleCal }}</p>
        </div>
        <form action="">
          <p>ancienne valeur: {{ windowObj.singleCal.dateFormat }}</p>
          <q-date
            v-model="updateCalendarDate"
            minimal
            title="champ vide = ancienne valeur"
          />
          <p>ancienne valeur: {{ windowObj.singleCal.value }}</p>
          <q-input
            filled
            v-model="updateCalendarValue"
            label="value"
            type="number"
            title="champ vide = ancienne valeur"
          />
          <br /><br />
          <q-btn
            @click.prevent="updateCalendar2(windowObj.fieldId)"
            label="enregistrer"
            type="submit"
            color="positive"
            icon="add"
          />
        </form>
        <form action="">
          <br />
          <q-btn
            @click.prevent="deleteCalendar(windowObj.singleCal)"
            label="supprimer cette date"
            type="submit"
            color="negative"
            icon="delete"
          />
        </form>
      </q-card-section>
    </q-card>
  </q-dialog>
</template>
<script>

import { defineComponent, ref } from 'vue';
import { useQuasar, useDialogPluginComponent } from 'quasar';
import { useAuthStore } from 'src/stores/authStore.js';

export default defineComponent({

  props: {
    windowObj: {
      type: Object,
      required: true,
    },
  },

  emits: [
    ...useDialogPluginComponent.emits,
  ],

  setup(props) {
    const maximizedToggleCal = ref(true);
    const addCalendarDate = ref('');
    const addCalendarValue = ref('');
    const updateCalendarDate = ref('');
    const updateCalendarValue = ref('');
    const quasar = useQuasar();
    const authStore = useAuthStore();
    const {
      dialogRef,
      onDialogHide,
      onDialogOK,
    } = useDialogPluginComponent();

    function calendarAddDateFormat(calendar) {
      const theDate = new Date(calendar.date);
      const year = theDate.getFullYear();
      let month = theDate.getMonth() + 1;
      if (month < 10) {
        month = `0${month}`;
      }
      let day = theDate.getDate();
      if (day < 10) {
        day = `0${day}`;
      }
      calendar.dateFormat = `${year}-${month}-${day}`;
      return calendar;
    }
    async function updateCalendar2() {
      const formResObj = {};
      if (updateCalendarDate.value === '' || updateCalendarDate.value === undefined || updateCalendarDate.value === null) {
        formResObj.date = props.windowObj.singleCal.date;
      } else {
        formResObj.date = updateCalendarDate.value;
      }
      if (updateCalendarValue.value === '' || updateCalendarValue.value === undefined || updateCalendarValue.value === null) {
        formResObj.value = props.windowObj.singleCal.value;
      } else {
        formResObj.value = Number(updateCalendarValue.value);
      }
      console.log('formResObj.date');
      console.log(formResObj.date);
      console.log('formResObj.value');
      console.log(formResObj.value);
      /* FETCH */
      const requestOptionsConn = {
        method: 'PUT',
        headers: {
          'Content-Type': 'application/json',
          Authorization: `Bearer ${authStore.jwt}`,
        },
        body: JSON.stringify({
          date: formResObj.date,
          value: formResObj.value,
        }),
      };
      fetch(`${import.meta.env.VITE_FETCH_BACK}/users/${authStore.userId}/champs/${props.windowObj.singleCal.fieldId}/calendar/${props.windowObj.singleCal._id}`, requestOptionsConn)
        .then((response) => {
          if (response.status !== 200) {
            quasar.dialog({
              title: 'Alert',
              message: 'un problème est survenu ...',
            });
            throw response.status;
          }
          return response.json();
        })
        .then((json) => {
          const updateCalendar = calendarAddDateFormat(json);
          onDialogOK(updateCalendar);
          quasar.notify({
            message: 'date modifier',
            color: 'positive',
            badgeTextColor: 'white',
            progress: true,
          });
          updateCalendarValue.value = '';
          updateCalendarDate.value = '';
        });
    }
    async function addCalendar2(fieldId) {
      // TU COMMENCE PAR VÉRIF LES DATAS
      if (addCalendarDate.value === '' || addCalendarDate.value === null || addCalendarValue.value === '' || addCalendarValue.value === null) {
        console.log("return 'error data enter'");
        quasar.notify({
          message: 'tous les champs doivent être renseigné',
          color: 'negative',
          badgeTextColor: 'white',
          progress: true,
        });
        return false;
      }
      const thisDate = new Date(addCalendarDate.value);
      const year = thisDate.getFullYear();
      let month = thisDate.getMonth() + 1;
      if (month < 10) {
        month = `0${month}`;
      }
      let day = thisDate.getDate();
      if (day < 10) {
        day = `0${day}`;
      }
      const dateFormat = `${month}-${day}-${year}`;
      /* FETCH */
      const requestOptionsConn = {
        method: 'POST',
        headers: {
          'Content-Type': 'application/json',
          Authorization: `Bearer ${authStore.jwt}`,
        },
        body: JSON.stringify({
          date: dateFormat.toString(),
          value: addCalendarValue.value.toString(),
        }),
      };
      fetch(`${import.meta.env.VITE_FETCH_BACK}/users/${authStore.userId}/champs/${fieldId}`, requestOptionsConn)
        .then((response) => {
          if (response.status !== 200) {
            quasar.dialog({
              title: 'Alert',
              message: 'un problème est survenu ...',
            });
            throw response.status;
          }
          return response.json();
        })
        .then((json) => {
          const newCalendar = calendarAddDateFormat(json);
          onDialogOK(newCalendar);
          quasar.notify({
            message: 'date créer',
            color: 'positive',
            badgeTextColor: 'white',
            progress: true,
          });
          addCalendarValue.value = '';
          addCalendarDate.value = '';
        });
    }
    async function deleteCalendar(cal) {
      console.log(cal);
      /* FETCH */
      const requestOptionsConn = {
        method: 'DELETE',
        headers: {
          Authorization: `Bearer ${authStore.jwt}`,
        },
      };
      fetch(
        `${import.meta.env.VITE_FETCH_BACK}/users/${authStore.userId}/champs/${cal.fieldId}/calendar/${cal._id}`,
        requestOptionsConn,
      )
        .then((response) => {
          if (response.status !== 200) {
            quasar.dialog({
              title: 'Alert',
              message: 'un problème est survenu ...',
            });
            throw response.status;
          }
          return response.json();
        })
        .then((json) => {
          console.log(json);
          onDialogOK(json);
          quasar.notify({
            message: 'date supprimer',
            color: 'positive',
            badgeTextColor: 'white',
            progress: true,
          });
        });
    }
    return {
      maximizedToggleCal,
      addCalendarDate,
      addCalendarValue,
      updateCalendarDate,
      updateCalendarValue,
      addCalendar2,
      updateCalendar2,
      deleteCalendar,
      dialogRef,
      onDialogHide,
    };
  },
});
</script>
